/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 05.08.2011
Author  : NeVaDa
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>

#include <delay.h>
unsigned char al=0;
unsigned char ar=0;
unsigned char starr=0;
unsigned long int tmheat; // 
eeprom unsigned char elvy=0;
eeprom unsigned int  elsy=0;
eeprom unsigned char elvx=0; 
eeprom unsigned int  elsx=0; 
eeprom unsigned char ervy=0; 
eeprom unsigned int  ersy=0;
eeprom unsigned char ervx=0; 
eeprom unsigned int  ersx=0; 
eeprom unsigned char pause=0; //   . 

#define ADC_VREF_TYPE 0xE0      

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}





// Timer2 output compare interrupt service routine
interrupt [TIM2_COMP] void timer2_comp_isr(void)
{
// Place your code here
  if (starr==0)
           {
            goto exi;
           }
   if (starr==2)
   {
    starr--; 
    read_adc(7); //L 
    al=ADCH;
    read_adc(6); //R
    ar=ADCH;  
    goto exi;
   } 
   if (starr==1)
   {
    starr=0;
    
   }
            
 
 exi: if (tmheat>0)
        //   
        {
         tmheat--;
         goto exi2;
        }  
        //        
        if (PINC&1==1)
        { 
          PORTC=32;
          goto exi2; 
          
          
        }
        
         PORTC=0;
 exi2: #asm("nop");   
}




// Declare your global variables here

void main(void)
{
// Declare your local variables here
      unsigned char lvy; //   Y
      unsigned int  lsy; //    Y 
      
      
      
   //----------------------------    
                                                      
      unsigned char lvx; //   X 
      unsigned int lsx; //    X 
      
  
         
   //----------------------------     
      unsigned char rvy; //   Y
      unsigned int rsy; //    Y 
    
      
   //---------------------------- 
      
      unsigned char rvx; //   X
      unsigned int rsx; //    X     
      
     
      
    //---------------------------- 
  unsigned char cancel=0;   //  
  
  unsigned int timer;
       
  unsigned char drive; 
  unsigned char port; 
  
  unsigned char pro=0; 
  unsigned char base=0; 
  
  
  unsigned int stl;
  unsigned int str;
  unsigned char temp;  //  
  unsigned int  templ; //  

   
  unsigned char lv1=0;   //    1
  unsigned char lv0=0;   //    0        
  
  unsigned char rv1=0;   //    1
  unsigned char rv0=0;   //    0 
  

   
  unsigned char lal=0; //    L
  unsigned char lar=0;   //    R 
   
  unsigned char gis=0; //   
  



// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x03;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x20;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0xFF;





// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;





// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: CTC top=OCR2
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x0A;
TCNT2=0x00;
OCR2=0xFA;


// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;



// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x80;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 1000,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x83;

// Global disable interrupts
#asm("cli")


      
      while (1)
      {
      // Place your code here
         delay_ms(10);  
       /*  
           1.   
           2.  
           3.    
                  -    
                  -     
                  -      
           4.           
        */ 
         
        
        
                    PORTB=1; 
                delay_us(10);
                temp=PINB;
              

    if (temp==145)                    //128+1+16
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                 //         
                    if (temp==134)    //128+2+4
                    // 
                    {      
                     
                     goto clear;      
                      
                    }  
                    
                       if (temp==162)     //128+2+32
                    // 
                    {      
                      
                      goto clear;     
                      
                    }
                  //                  
                      if (temp==138)     //128+2+8
                    // 
                    {      
                      
                      goto pause0;      
                      
                    }
                            if (temp==194)       //128+2+64
                    //  
                    {      
                     
                      goto pause0;      
                      
                    } 
                }

           //              
       
    if (temp==137||temp==193)                        //128+1+8        128+1+64
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                   
                    if (temp==146)         //128+2+16
                    //      
                    {      
                     
                      goto pause1;      
                      
                    } 
               
                    
                
                }        
                goto ini;
                
    pause0:
        //    
             
        
        read_adc(4);
        if (ADCH<83)
        {          
         gis=1;
         goto ini;
        } 
        
        pause=0;
        goto ini2; 
     
    pause1:
       //    
           read_adc(4);
        if (ADCH<83)
        {  
         gis=1;
         goto ini;
        } 
        pause=1;
        goto ini2;  
                     
    clear:  
        //  
       
        read_adc(4);
        if (ADCH<83)
        { 
         gis=1;
         goto ini;
        } 
        
      elvy=0;
      elsy=0;
      elvx=0; 
      elsx=0; 
      
      ervy=0; 
      ersy=0;
      ervx=0; 
      ersx=0; 
               
ini2:  delay_ms(5000);
          
      // 
ini:      #asm("cli");  //  
          delay_ms(100);
          
        
            
       tmheat=0;
       PORTB=0; 
       PORTC=0;  
       PORTD=0;
       
         // 
          
          read_adc(4); 
          temp=ADCH;
          if (temp<83)         //10,5v 
           {
            goto ini; 
            gis=1;
           } 
           
     
            if (temp>94)       //11,5v  91
            //  
           {
            gis=0;
           } 
           
           if (gis==1)
           {
            goto ini;
           }
           
           
      lvy=elvy; 
      lsy=elsy;
      lvx=elvx;
      lsx=elsx; 
       
      rvy=ervy;
      rsy=ersy;
      rvx=ervx;
      rsx=ersx; 
      
     
       
      if (lsy>2000)
       {
        lsy=0;
       }
      if (lsx>2000)
       {
        lsx=0;
       }  
      if (rsy>2000)
       {
        rsy=0;
       }
      if (rsx>2000)
       {
        rsx=0;
       } 
       
      if (lvy!=96)    
       {
        if(lvy!=80)    
         {
          lvy=0;
         }
        
       }
      if (lvx!=160)       
       {
        if(lvx!=144)      
         {
          lvx=0;
         }
        
       } 
      if (rvy!=6)     
       {
        if(rvy!=5)      
         {
          rvy=0;
         }
        
       }
      if (rvx!=9)      
       {
        if(rvx!=10)     
         {
          rvx=0;
         }
        
       }  
          base=10;
          #asm("sei");
          
main: switch (base)
   {  
   
     case 10:
     
     {  
        // 
        #asm("cli"); 
        read_adc(4);
        if (ADCH<83)
        {  
         gis=1;
         goto ini;
        } 
        
        if (gis==1)
        {
         goto ini;
        }
        
        #asm("sei");
        
        temp=PINB;
        temp=temp&128;
        if (temp==0)
        //  rear=0
         { 
          cancel=0;
          base=20;  //   
          goto main;
         }  
        if (cancel==1)
         {
          base=20;  //   
          goto main;
         } 
         
        timer=200;   //    
        if (pause>0)
       
        { 
         timer=6000; //   1,5 .  
        }
        
wait2s:         starr=1;
wait2:          if (starr==1)
                 {
                  goto wait2;
                 } 
       timer--;
       if (timer!=0)
        {
         goto wait2s;
        } 

        temp=PINB;
        temp=temp&128;
        if (temp==0)
         {
          base=20; //   
          goto main;
         }
         
        base=1;  // rear 
        goto main;
                
     } 
     
     case 20:
      //   
     {
      
                 PORTB=1; 
                delay_us(10);
                temp=PINB;
                temp=temp&127;
                if (temp==5)           //1+4
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                    temp=temp&127;
                    if (temp==18)      //2+16
                    // 
                    {      
                      port=80;        
                      goto scan0;      
                      
                    } 
                    
                     goto scanp; 
                } 
                
                if (temp==17)            //1+16 
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                     temp=temp&127;
                    if (temp==6)        //2+4
                    // 
                    {      
                      port=96;         
                      goto scan0;      
                      
                    }
                  
                    
                       if (temp==10)       //2+8
                    // 
                    {      
                      port=160;   
                      goto scan0;      
                      
                    }   
                      if (temp==34)        //2+32
                    // 
                    {      
                      port=6;       
                      goto scan0;      
                      
                    }  
                    
                       if (temp==66)       //2+64
                    //  
                    {      
                      port=10;     
                      goto scan0;      
                      
                    } 
                    goto scanp; 
                    
                    
                }
                
                 if (temp==9)            //1+8
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                     temp=temp&127;
                    if (temp==18)         //2+16
                    // 
                    {      
                      port=144;      
                      goto scan0;      
                      
                    }  
                    
                    
                 
                    goto scanp;
                }
                
                 if (temp==33)
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                     temp=temp&127;
                    if (temp==18)       //2+16
                    // 
                    {      
                      port=5;      
                      goto scan0;      
                      
                    } 
                
                    
                    
                    goto scanp;
                }
                 if (temp==65)          //1+64
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                     temp=temp&127;  
                     
                       if (temp==18)    //2+16
                    //  
                    {      
                      port=9;   
                      goto scan0;      
                      
                    } 
                 
                }  
scanp:          port=0;

scan0:     
       if (tmheat==0)
       {
        if (port==5||port==80)   
        {
          timer=4000; //  1    
       
wait10s:   starr=1;
wait10:    if (starr==1)
                 {
                  goto wait10;
                 } 
          timer--;
          if (timer!=0)
           {
            goto wait10s;
           } 
          tmheat=3600000;   //   15   
           //tmheat=20000;
           PORTC=32;  
           base=10;
           goto main;     
        }
       }

       PORTD=port;
       base=10;
       goto main;
     } 
     
     case 30:
     // 
     {
        temp=PINB;
        temp=temp&128;
        if (temp==0)
        //  
        {
         base=6; //
         goto main;
        }
        
        if (cancel==1)
        //   
        {
          base=6; //
          goto main;
        } 
        pro=1;
        goto driver;

     }
     
     case 1:
     // rear  
     { 
     
      stl=lsy;
      str=rsy;
            
      drive=lvy;
      drive=drive+rvy; 
      
    
          
      base=5;
      pro=0;  
      goto driver;
     } 
     
     
      
      case 5:
      {          
       stl=lsx;
       str=rsx;
               
       drive=lvx;
       drive=drive+rvx;
       
        base=30;
        pro=0;
       goto driver;
     
      }
      
 
       case 6:
       //  rear 
      { 
       stl=lsx;
       str=rsx;
       
       drive=160;       
       if (lvx==160)    
       {
        drive=144;    
       }
       
        temp=10;        
       if (rvx==10)      
       {
        temp=9;
       } 
       
       drive=drive+temp;         
      

       base=7;
       pro=0;
       goto driver;
     
      } 
            case 7:
       
      { 
             
    
       stl=lsy;
       str=rsy;
       
       drive=80;                 
       if (lvy==80)            
       {
        drive=96;    
       }
       
        temp=5;             
       if (rvy==5)          
       {
        temp=6;            
       } 
       
       drive=drive+temp;
       
         
       
       base=8;
       pro=0;
       goto driver;
     
      } 
      case  8:
      //  eeprom 
      {
          // 
          #asm("cli"); 
          read_adc(4);
          if (ADCH<83)
           { 
            gis=1;
            goto ini;
           }  
              if (gis==1)
        {
         goto ini;
        }
           
          #asm("sei");  
      
       if (lvy!=elvy)
       {
        elvy=lvy;
       }   
       if (lsy!=elsy)
       {
        elsy=lsy;
       }
       if (lvx!=elvx)
       {
        elvx=lvx;
       }
       if (lsx!=elsx)
       {
        elsx=lsx;
       }
       if (rvy!=ervy)
       {
        ervy=rvy;
       }   
       if (rsy!=ersy)
       {
        ersy=rsy;
       }
       if (rvx!=ervx)
       {
        ervx=rvx;
       }
       if (rsx!=ersx)
       {
        ersx=rsx;
       }
       base=10;
       goto main;
      }
   } 
   
 goto ini;                     
 
 //     
 // stl -    
 // str -    
 // drive - L , R  
 
 driver:   switch (pro)
       { 
                case 1:
         { 
              
                 templ=0;
         
                 
                 lv1=0;
                 lv0=0;
                 rv1=0;
                 rv0=0;
                
 scan:          PORTB=1; 
              
                delay_us(10);
                temp=PINB;
                temp=temp&127;
                if (temp==5)           //1+4
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                    temp=temp&127;
                    if (temp==18)      //2+16
                    // 
                    {      
                      port=80;        
                      goto scan2;      
                      
                    } 
                    
                     goto scanex; 
                } 
                
                if (temp==17)            //1+16 
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                     temp=temp&127;
                    if (temp==6)        //2+4
                    // 
                    {      
                      port=96;         
                      goto scan2;      
                      
                    }
                  
                    
                       if (temp==10)       //2+8
                    // 
                    {      
                      port=160;   
                      goto scan2;      
                      
                    }   
                      if (temp==34)        //2+32
                    // 
                    {      
                      port=6;       
                      goto scan2;      
                      
                    }  
                    
                       if (temp==66)       //2+64
                    //  
                    {      
                      port=10;     
                      goto scan2;      
                      
                    } 
                    goto scanex; 
                    
                    
                }
                
                 if (temp==9)            //1+8
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                     temp=temp&127;
                    if (temp==18)         //2+16
                    // 
                    {      
                      port=144;      
                      goto scan2;      
                      
                    }  
                    
                    
                 
                    goto scanex;
                }
                
                 if (temp==33)
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                     temp=temp&127;
                    if (temp==18)       //2+16
                    // 
                    {      
                      port=5;      
                      goto scan2;      
                      
                    } 
                
                    
                    
                    goto scanex;
                }
                 if (temp==65)          //1+64
                {
                    PORTB=2; 
                    delay_us(10);
                    temp=PINB;
                     temp=temp&127;  
                     
                       if (temp==18)    //2+16
                    //  
                    {      
                      port=9;   
                      goto scan2;      
                      
                    } 
                 
                }  
                //--------------
scanex:          port=0;
                 
                 PORTD=0;
                      
scan2:           temp=PINB;
                 temp=temp&128;
                 if (temp==0)
                   {
                    base=6; //
                    goto main;
                   }
                   
                 if (port==80||port==96)  
                {
                  goto start1;
                } 
                
                  if (port==160||port==144)    
                {
                 goto start3;
                }   
                
                 if (port==5||port==6)  
                {
                  goto start2;
                } 
               
                 if (port==9||port==10)  
                {
                  goto start6;
                } 
                goto scan; 
                  
              
                 //    Y
start1:          if (lsy==2000)
                {
                 if (lvy==80&&port==96)    
                 {
                  goto start11;
                 }
                   if (lvy==96&&port==80)    
                 {
                  goto start11;
                 }
                 PORTD=0;
                 goto scan;
                }  
             

start11:        PORTD=port;
                       
                starr=0;
                starr=2;
                          
 wait3:          if (starr==2)
                 {
                  goto wait3;
                 }
                               
                 
                 if (al>0)
                 {
                 
                   if (lv0>2)
                   { 
                   
                    lv1=1;
                    lv0=0;
                    lal=1;
                    goto next3;
                   }
                   
                   lv0=0;
                   lv1++;
                   goto next3;
                 } 
                  
                  lv1=0;
                  lv0++;
                                 
                 if (lal==1)
                 { 
                  if (lv0>2)
                   {
                    lal=0;
                    lv0=0;
                    
                    if(lvy==port)
                    {
                     lsy++;
                     if(lsy>2000)
                     {
                      lsy=2000;
                      
                      PORTD=0;
                      delay_ms(500);
                      goto scan;
                     }
                     goto next3;
                     
                    } 
                    
                    if (lsy==0)
                    {
                      PORTD=0;
                      lvy=port;
                      delay_ms(500);
                      goto scan;
                    }
                    lsy--;
                    
                    
                   
                   }
                 } 
                                         
next3:                     
                 goto  scan;

                  //    X 
 start3:                if (lsx==2000)
                {
                 if (lvx==160&&port==144)    
                 {
                  goto start31;
                 }
                   if (lvx==144&&port==160)   
                 {
                  goto start31;
                 }
                 goto scan;
                }   
                
start31:         PORTD=port;
                               
                 starr=0;
                 starr=2;
                               
 wait5:          if (starr==2)
                 {
                  goto wait5;
                 }
                                 
                 if (al>0)
                 {
                 
                   if (lv0>2)
                   { 
                   
                    lv1=1;
                    lv0=0;
                    lal=1;
                    goto next5;
                   }
                   
                   lv0=0;
                   lv1++;
                   goto next5;
                 } 
                  
                  lv1=0;
                  lv0++;
                                
                 if (lal==1)
                 { 
                  if (lv0>2)
                   {
                    lal=0;
                    lv0=0;
                    
                    if(lvx==port)
                    {
                     lsx++;
                     if(lsx>2000)
                     {
                      lsx=2000;
                      
                      PORTD=0;
                      delay_ms(500);
                      goto scan;
                     }
                     goto next5;
                     
                    } 
                    
                    if (lsx==0)
                    {
                      PORTD=0;
                      lvx=port;
                      delay_ms(500);
                      goto scan;
                    }
                    lsx--;
                    
                    
                   
                   }
                 } 
                                     
next5:                   
              goto  scan;
                    
       //      Y
                           
                
start2:          if (rsy==2000)
                {
                 if (rvy==6&&port==5)   
                 {
                  goto start21;
                 }
                   if (rvy==5&&port==6)     
                 {
                  goto start21;
                 }
                 PORTD=0;
                 goto scan;
                }  
               
start21:        PORTD=port;
                        
                starr=0;
                starr=2;
                              
 wait4:          if (starr==2)
                 {
                  goto wait4;
                 }
                                                 
                 if (ar>0)
                 {
                  if (rv0>2)
                   { 
                    rv1=1;
                    rv0=0;
                    lar=1;
                    goto next4;
                   }
                   
                   rv0=0;
                   rv1++;
                   goto next4;
                 } 
                  
                  rv1=0;
                  rv0++;
                                  
                 if (lar==1)
                 { 
                  if (rv0>2)
                   {
                    lar=0;
                    rv0=0;
                    
                    if(rvy==port)
                    {
                     rsy++;
                     if(rsy>2000)
                     {
                      rsy=2000;
                      
                      PORTD=0;
                      delay_ms(500);
                      goto scan;
                     }
                     goto next4;
                     
                    } 
                    
                    if (rsy==0)
                    {
                      PORTD=0;
                      rvy=port;
                      delay_ms(500);
                      goto scan;
                    }
                    rsy--;
                    
                    
                   
                   }
                 } 
                                       
next4:       
                 goto  scan;

                  //    X 
start6:                if (rsx==2000)
                {
                 if (rvx==10&&port==9)     
                 {
                  goto start61;
                 }
                   if (rvx==9&&port==10)       
                 {
                  goto start61;
                 }
                 goto scan;
                } 
                
start61:        PORTD=port;
                            
                starr=0;
                starr=2;
                             
 wait6:          if (starr==2)
                 {
                  goto wait6;
                 }
               
                                
                 if (ar>0)
                 {
                  if (rv0>2)
                   { 
                   
                    rv1=1;
                    rv0=0;
                    lar=1;
                    goto next6;
                   }
                   
                   rv0=0;
                   rv1++;
                   goto next6;
                 } 
                  
                 rv1=0;
                 rv0++;
                         
                 if (lar==1)
                 { 
                  if (rv0>2)
                   {
                    lar=0;
                    rv0=0;
                    
                    if(rvx==port)
                    {
                     rsx++;
                     if(rsx>2000)
                     {
                      rsx=2000;
                      
                      PORTD=0;
                      delay_ms(500);
                      goto scan;
                     }
                     goto next6;
                     
                    } 
                    
                    if (rsx==0)
                    {
                      PORTD=0;
                      rvx=port;
                      delay_ms(500);
                      goto scan;
                    }
                    rsx--;
                    
                    
                   
                   }
                 } 
                                       
next6:                      
                goto  scan;
                          
         }
                case 0:
                
                { 
                 lv1=0;
                 lv0=0;
                 rv1=0;
                 rv0=0;
                 
                temp=3; //L=1 R=2 1+2=3 
                if (stl==0)
                
                {
                 temp=temp&2;
                } 
                 if (str==0)
                
                {
                 temp=temp&1;
                }
                
                if (temp==0)
                { 
                  //    0  
                 
                 goto main;
                }
                port=drive;
                 
                //
                if (stl==0)
                {
                  // 
                  port=port&0x0f;     
                } 
                 if (str==0)
                {
                   //   
                 port=port&0xf0;     
        
                } 
                PORTD=port;
                
                
                starr=0;
                starr=2;
                 
                 
 wait:          if (starr==2)
                 {
                  goto wait;
                 } 
                 
   //--              //   
                 //      
                 
                 PORTB=1; 
              
                delay_us(10);
                temp=PINB;
                temp=temp&127;
                if (temp==5||temp==33)           //1+4      1+32
                 {   
                    PORTB=2; 
                    delay_us(5);
                    temp=PINB;
                    temp=temp&127;
                    if (temp==18)              //2+16
                    //    
                    {      
                     cancel=1;
                    }
                  
                 } 
                 
                 
                 
               
                    
                    //  
                    //     
                      temp=PINB;
                      temp=temp&128;
                      if (temp==0)
                      //  
                       {
                         cancel=1;
                       }
                    
                 
                 if (al>0)
                 {
                  if (lv0>2)
                   { 
                    lv1=1;
                    lv0=0;
                    lal=1;
                    goto next1;
                   }
                   
                   lv0=0;
                   lv1++;
                   goto next1;
                 } 
                  
                  lv1=0;
                  lv0++;
                  
                                  
                 if (lal==1)
                 { 
                  if (lv0>2)
                   {
                    lal=0;
                    lv0=0;
                    stl--;
                   }
                 } 
                 
                         
next1:            
                 if (ar>0)
                 {
                  if (rv0>2)
                   { 
                    rv1=1;
                    rv0=0;
                    lar=1;
                    goto next2;
                   }
                   
                   rv0=0;
                   rv1++;
                   goto next2;
                 } 
                  
                  rv1=0;
                  rv0++;
                  
                 
                 
                 if (lar==1)
                 { 
                  if (rv0>2)
                   {
                    lar=0;
                    rv0=0;
                    str--;
                   }
                 } 
                  
                 
next2:           if (stl==0||lv1>254||lv0>254)
                  {
                 
                  port=port&0x0F;
                  } 
                
                   
                  if (str==0||rv1>254||rv0>254)
                  {
                  
                  port=port&0xF0;
                  } 
                 
                  
                  PORTD=port;
                  if (port==0)
                  {   
                   
                   delay_ms(100);
                   
                   //  
                   goto main;
                  } 
                
                  starr=2;
                  goto wait;
                  
                 goto main;
                }
       } 
              
 goto ini;
  };
}
         /*
           
           
           
           PORTB=1; 
                               
           
              4          32
               16         16
              16         16
             8          64
           
           PORTB=2; 
                       
                 
             16          16
              4           32
             8           64
            16          16
           
          //

       PORTD=80;  //       
       PORTD=96;  //                  
       PORTD=160;  //  
       PORTD=144; //  
             
      //  

       PORTD=5;  //       
       PORTD=6;  //         
       PORTD=10; //       
       PORTD=9; //     
           
           
           */
                 
           
                 /*
     
         +
         +  
        
        
     
        */
        

